import { savePoint, updatePoint } from '@/services/common'

// 此处映射需要与 td_biz_event_type 一致
const pathEventTypeMap = {
  // '' : 'agent',  // 暂时不需要
  // '' : 'info',  // 暂时不需要
  'pages/activity/detail/index' : { type: 'activity', desc: '活动' },
  'pages/activity/detail/assistance' : { type: 'activity', desc: '活动' },
  'pages/activity/detail/assemble' : { type: 'activity', desc: '活动' },
  'pages/project/detail/index' : { type: 'building', desc: '项目' },
  'pages/card/index' : { type: 'card', desc: '名片' },
  'pages/project/index' : { type: 'main', desc: '首页' },
  'pages/news/detail/index' : { type: 'news', desc: '资讯' },
  'pages/project/h5Page': { type: 'h5', desc: 'H5' },
}

/**
 * 用户来源
 * @param {*} router 
 */
export async function trackUserSource(router) {
  const { path, query, scene } = router || {}

  const pageInfo = pathEventTypeMap['path'] || { type: '', desc: '其他' }

  const trackPayload = {
    event: 'start',
    eventType: pageInfo.type,
    propertyName: pageInfo.desc,
    data: '{}',
    id: (query || {}).id,
    sceneId: scene,
    sharePersonId: (query || {}).recommender,
  }

  try {

    const { recordId } = await savePoint(trackPayload)
    return function () { updatePoint(recordId); }

  } catch (e) {
    console.error('进入小程序埋点出错:', e);
    return function(){}
  }
}
